
%% initialize
ftvq_startup;
ids= regexp(ls('sample_images'),'(\w*).(jpg|JPG)','match')';
models_dir = './cascade_models/';
load 'clustercenters_2level.mat';
C=C2;
C12=[C1 C2];

%% load models

models=cell(20,1);
for i=1:20
    cls=classes{i};
    load([models_dir cls '_cascade_final.mat'], '-mat','model'); %_dpi0.5
    model.interval=2;
    model = model_add_lut(model,C);
    [model.compressed_root_lut,model.compressed_part_lut]= conv_lut_fast8_13x13_16bit_makelut(model.rootlut,model.partlut);
    model.loc_scores=model_loc_scores(model);
    models{i}=model;
end

%% Load and process image
num_ids = length(ids);
ds_out = cell(num_ids,20);

for i=ones(1,100)*3
    % Load image
    im = imread(sprintf('sample_images/%s', ids{i}));

    %% detect
    coords = amin_cascade_detect_joint(im, models,C12);
    
    
    % nms
    for j=1:20
        select=coords(5,:)==j;
        ds =coords([1:4 end-1 end],select)';
        if ~isempty(ds)
            [ds, ~] = clipboxes(im, ds, []);
            I = nms(ds, 0.5);
            ds_out{i,j} = ds(I,[1:4 end]);
        else
            ds_out{i,j} = [];
        end
    end
end


